#

API Docs for: v2.11.1
Show: Inherited Protected Private Deprecated

# Ember.EngineInstance Class

Uses

- RegistryProxyMixin
- ContainerProxyMixin

Extends Ember.Object
Defined in: `packages/ember-application/lib/system/engine-instance.js:17`
Module: ember-application
Parent Module: ember

The `EngineInstance` encapsulates all of the stateful aspects of a running `Engine`.

- Index
- Methods
- Properties

## Item Index

### Methods

- _lazyInjections
- _lookupFactory
- _onLookup
- _resolveLocalLookupName
- _scheduledDestroy
- addObserver
- beginPropertyChanges
- boot
- buildChildEngineInstance
- cacheFor
- cloneParentDependencies
- decrementProperty
- destroy
- endPropertyChanges
- get
- getProperties
- getWithDefault
- hasObserverFor
- hasRegistration
- incrementProperty
- init
- inject
- lookup
- notifyPropertyChange
- ownerInjection
- propertyDidChange
- propertyWillChange
- register
- registeredOption
- registeredOptions
- registeredOptionsForType
- registerOption
- registerOptions
- registerOptionsForType
- removeObserver
- reopen
- reopenClass
- resolveRegistration
- set
- setProperties
- setupRegistry
- toggleProperty
- toString
- unregister
- willDestroy

### Properties

- __container__
- concatenatedProperties
- engine
- isDestroyed
- isDestroying
- mergedProperties

## Methods

### `_lazyInjections`

() Object private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:930`

Returns a hash of property names and container names that injected properties will lookup on the container lazily.

#### Returns:

Object: Hash of all lazy injected property keys to container names

### `_lookupFactory`

(

- `fullName`

)
Any private

Inherited from ContainerProxyMixin: `packages/ember-runtime/lib/mixins/container_proxy.js:97`

Given a fullName return the corresponding factory.

#### Parameters:

- `fullName` String

#### Returns:

Any:

### `_onLookup`

() private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:921`

Provides lookup-time type validation for injected properties.

### `_resolveLocalLookupName`

(

- `fullName`
- `source`

)
String private

Inherited from ContainerProxyMixin: `packages/ember-runtime/lib/mixins/container_proxy.js:109`

Given a name and a source path, resolve the fullName

#### Parameters:

- `fullName` String
- `source` String

#### Returns:

String:

### `_scheduledDestroy`

() private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:487`

Invoked by the run loop to actually destroy the object. This is scheduled for execution by the `destroy` method.

### `addObserver`

(

- `key`
- `target`
- `method`

)
public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:333`

Adds an observer on a property. This is the core method used to register an observer for a property. Once you call this method, any time the key's value is set, your observer will be notified. Note that the observers are triggered any time the value is set, regardless of whether it has actually changed. Your observer should be prepared to handle that. You can also pass an optional context parameter to this method. The context will be passed to your observer method whenever it is triggered. Note that if you add the same target/method pair on a key multiple times with different context parameters, your observer will only be called once with the last context you passed. ### Observer Methods Observer methods you pass should generally have the following signature if you do not pass a `context` parameter: ```javascript fooDidChange: function(sender, key, value, rev) { }; ``` The sender is the object that changed. The key is the property that changes. The value property is currently reserved and unused. The rev is the last property revision of the object when it changed, which you can use to detect if the key value has really changed or not. If you pass a `context` parameter, the context will be passed before the revision like so: ```javascript fooDidChange: function(sender, key, value, context, rev) { }; ``` Usually you will not need the value, context or revision parameters at the end. In this case, it is common to write observer methods that take only a sender and key value as parameters or, if you aren't interested in any of these values, to write an observer that has no parameters at all.

#### Parameters:

- `key` String
  The key to observer
- `target` Object
  The target object to invoke
- `method` String | Function
  The method to invoke.

### `beginPropertyChanges`

() Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:231`

Begins a grouping of property changes. You can use this method to group property changes so that notifications will not be sent until the changes are finished. If you plan to make a large number of changes to an object at one time, you should call this method at the beginning of the changes to begin deferring change notifications. When you are done making changes, call `endPropertyChanges()` to deliver the deferred change notifications and end deferring.

#### Returns:

Ember.Observable:

### `boot`

(

- `options`

)
Promise private

Defined in `packages/ember-application/lib/system/engine-instance.js:61`

Initialize the `Ember.EngineInstance` and return a promise that resolves with the instance itself when the boot process is complete.

The primary task here is to run any registered instance initializers.

See the documentation on `BootOptions` for the options it takes.

#### Parameters:

- `options` Object

#### Returns:

Promise:

### `buildChildEngineInstance`

(

- `name`
- `options`

)
Ember.EngineInstance,Error private

Defined in `packages/ember-application/lib/system/engine-instance.js:139`

Build a new `Ember.EngineInstance` that's a child of this instance.

Engines must be registered by name with their parent engine (or application).

#### Parameters:

- `name` String

  the registered name of the engine.

- `options` Object

  options provided to the engine instance.

#### Returns:

Ember.EngineInstance,Error:

### `cacheFor`

(

- `keyName`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:490`

Returns the cached value of a computed property, if it exists. This allows you to inspect the value of a computed property without accidentally invoking it if it is intended to be generated lazily.

#### Parameters:

- `keyName` String

#### Returns:

Object: The cached value of the computed property, if any

### `cloneParentDependencies`

() private

Defined in `packages/ember-application/lib/system/engine-instance.js:165`

Clone dependencies shared between an engine instance and its parent.

### `decrementProperty`

(

- `keyName`
- `decrement`

)
Number public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:453`

Set the value of a property to the current value minus some amount. ```javascript player.decrementProperty('lives'); orc.decrementProperty('health', 5); ```

#### Parameters:

- `keyName` String
  The name of the property to decrement
- `decrement` Number
  The amount to decrement by. Defaults to 1

#### Returns:

Number: The new property value

### `destroy`

() Ember.Object public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:453`

Destroys an object by setting the `isDestroyed` flag and removing its metadata, which effectively destroys observers and bindings. If you try to set a property on a destroyed object, an exception will be raised. Note that destruction is scheduled for the end of the run loop and does not happen immediately. It will set an isDestroying flag immediately.

#### Returns:

Ember.Object: receiver

### `endPropertyChanges`

() Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:251`

Ends a grouping of property changes. You can use this method to group property changes so that notifications will not be sent until the changes are finished. If you plan to make a large number of changes to an object at one time, you should call `beginPropertyChanges()` at the beginning of the changes to defer change notifications. When you are done making changes, call this method to deliver the deferred change notifications and end deferring.

#### Returns:

Ember.Observable:

### `get`

(

- `keyName`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:96`

Retrieves the value of a property from the object. This method is usually similar to using `object[keyName]` or `object.keyName`, however it supports both computed properties and the unknownProperty handler. Because `get` unifies the syntax for accessing all these kinds of properties, it can make many refactorings easier, such as replacing a simple property with a computed property, or vice versa. ### Computed Properties Computed properties are methods defined with the `property` modifier declared at the end, such as: ```javascript fullName: Ember.computed('firstName', 'lastName', function() { return this.get('firstName') + ' ' + this.get('lastName'); }) ``` When you call `get` on a computed property, the function will be called and the return value will be returned instead of the function itself. ### Unknown Properties Likewise, if you try to call `get` on a property whose value is `undefined`, the `unknownProperty()` method will be called on the object. If this method returns any value other than `undefined`, it will be returned instead. This allows you to implement "virtual" properties that are not defined upfront.

#### Parameters:

- `keyName` String
  The property to retrieve

#### Returns:

Object: The property value or undefined.

### `getProperties`

(

- `list`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:139`

To get the values of multiple properties at once, call `getProperties` with a list of strings or an array: ```javascript record.getProperties('firstName', 'lastName', 'zipCode'); // { firstName: 'John', lastName: 'Doe', zipCode: '10011' } ``` is equivalent to: ```javascript record.getProperties(['firstName', 'lastName', 'zipCode']); // { firstName: 'John', lastName: 'Doe', zipCode: '10011' } ```

#### Parameters:

- `list` String... | Array
  of keys to get

#### Returns:

Object:

### `getWithDefault`

(

- `keyName`
- `defaultValue`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:415`

Retrieves the value of a property, or a default value in the case that the property returns `undefined`. ```javascript person.getWithDefault('lastName', 'Doe'); ```

#### Parameters:

- `keyName` String
  The name of the property to retrieve
- `defaultValue` Object
  The value to return if the property value is undefined

#### Returns:

Object: The property value or the defaultValue.

### `hasObserverFor`

(

- `key`

)
Boolean private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:400`

Returns `true` if the object currently has observers registered for a particular key. You can use this method to potentially defer performing an expensive action until someone begins observing a particular property on the object.

#### Parameters:

- `key` String
  Key to check

#### Returns:

Boolean:

### `hasRegistration`

(

- `fullName`

)
Boolean public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:112`

Check if a factory is registered.

#### Parameters:

- `fullName` String

#### Returns:

Boolean:

### `incrementProperty`

(

- `keyName`
- `increment`

)
Number public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:433`

Set the value of a property to the current value plus some amount. ```javascript person.incrementProperty('age'); team.incrementProperty('score', 2); ```

#### Parameters:

- `keyName` String
  The name of the property to increment
- `increment` Number
  The amount to increment by. Defaults to 1

#### Returns:

Number: The new property value

### `init`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:218`

An overridable method called when objects are instantiated. By default, does nothing unless it is overridden during class definition. Example: ```javascript const Person = Ember.Object.extend({ init() { alert(`Name is ${this.get('name')}`); } }); let steve = Person.create({ name: "Steve" }); // alerts 'Name is Steve'. ``` NOTE: If you do override `init` for a framework class like `Ember.View`, be sure to call `this._super(...arguments)` in your `init` declaration! If you don't, Ember may not have an opportunity to do important setup work, and you'll see strange behavior in your application.

### `inject`

(

- `factoryNameOrType`
- `property`
- `injectionName`

)
public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:205`

Define a dependency injection onto a specific factory or all factories of a type. When Ember instantiates a controller, view, or other framework component it can attach a dependency to that component. This is often used to provide services to a set of framework components. An example of providing a session object to all controllers: ```javascript let App = Ember.Application.create(); let Session = Ember.Object.extend({ isAuthenticated: false }); // A factory must be registered before it can be injected App.register('session:main', Session); // Inject 'session:main' onto all factories of the type 'controller' // with the name 'session' App.inject('controller', 'session', 'session:main'); App.IndexController = Ember.Controller.extend({ isLoggedIn: Ember.computed.alias('session.isAuthenticated') }); ``` Injections can also be performed on specific factories. ```javascript App.inject(, , ) App.inject('route', 'source', 'source:main') App.inject('route:application', 'email', 'model:email') ``` It is important to note that injections can only be performed on classes that are instantiated by Ember itself. Instantiating a class directly (via `create` or `new`) bypasses the dependency injection system. **Note:** Ember-Data instantiates its models in a unique manner, and consequently injections onto models (or all models) will not work as expected. Injections on models can be enabled by setting `EmberENV.MODEL_FACTORY_INJECTIONS` to `true`.

#### Parameters:

- `factoryNameOrType` String
- `property` String
- `injectionName` String

### `lookup`

(

- `fullName`
- `options`

)
Any public

Inherited from ContainerProxyMixin: `packages/ember-runtime/lib/mixins/container_proxy.js:49`

Given a fullName return a corresponding instance. The default behaviour is for lookup to return a singleton instance. The singleton is scoped to the container, allowing multiple containers to all have their own locally scoped singletons. ```javascript let registry = new Registry(); let container = registry.container(); registry.register('api:twitter', Twitter); let twitter = container.lookup('api:twitter'); twitter instanceof Twitter; // => true // by default the container will return singletons let twitter2 = container.lookup('api:twitter'); twitter2 instanceof Twitter; // => true twitter === twitter2; //=> true ``` If singletons are not wanted an optional flag can be provided at lookup. ```javascript let registry = new Registry(); let container = registry.container(); registry.register('api:twitter', Twitter); let twitter = container.lookup('api:twitter', { singleton: false }); let twitter2 = container.lookup('api:twitter', { singleton: false }); twitter === twitter2; //=> false ```

#### Parameters:

- `fullName` String
- `options` Object

#### Returns:

Any:

### `notifyPropertyChange`

(

- `keyName`

)
Ember.Observable public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:318`

Convenience method to call `propertyWillChange` and `propertyDidChange` in succession.

#### Parameters:

- `keyName` String
  The property key to be notified about.

#### Returns:

Ember.Observable:

### `ownerInjection`

() Object public

Inherited from ContainerProxyMixin: `packages/ember-runtime/lib/mixins/container_proxy.js:26`

Returns an object that can be used to provide an owner to a manually created instance. Example: ``` let owner = Ember.getOwner(this); User.create( owner.ownerInjection(), { username: 'rwjblue' } ) ```

#### Returns:

Object:

### `propertyDidChange`

(

- `keyName`

)
Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:294`

Notify the observer system that a property has just changed. Sometimes you need to change a value directly or indirectly without actually calling `get()` or `set()` on it. In this case, you can use this method and `propertyWillChange()` instead. Calling these two methods together will notify all observers that the property has potentially changed value. Note that you must always call `propertyWillChange` and `propertyDidChange` as a pair. If you do not, it may get the property change groups out of order and cause notifications to be delivered more often than you would like.

#### Parameters:

- `keyName` String
  The property key that has just changed.

#### Returns:

Ember.Observable:

### `propertyWillChange`

(

- `keyName`

)
Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:270`

Notify the observer system that a property is about to change. Sometimes you need to change a value directly or indirectly without actually calling `get()` or `set()` on it. In this case, you can use this method and `propertyDidChange()` instead. Calling these two methods together will notify all observers that the property has potentially changed value. Note that you must always call `propertyWillChange` and `propertyDidChange` as a pair. If you do not, it may get the property change groups out of order and cause notifications to be delivered more often than you would like.

#### Parameters:

- `keyName` String
  The property key that is about to change.

#### Returns:

Ember.Observable:

### `register`

(

- `fullName`
- `factory`
- `options`

)
public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:31`

Registers a factory that can be used for dependency injection (with `inject`) or for service lookup. Each factory is registered with a full name including two parts: `type:name`. A simple example: ```javascript let App = Ember.Application.create(); App.Orange = Ember.Object.extend(); App.register('fruit:favorite', App.Orange); ``` Ember will resolve factories from the `App` namespace automatically. For example `App.CarsController` will be discovered and returned if an application requests `controller:cars`. An example of registering a controller with a non-standard name: ```javascript let App = Ember.Application.create(); let Session = Ember.Controller.extend(); App.register('controller:session', Session); // The Session controller can now be treated like a normal controller, // despite its non-standard name. App.ApplicationController = Ember.Controller.extend({ needs: ['session'] }); ``` Registered factories are **instantiated** by having `create` called on them. Additionally they are **singletons**, each time they are looked up they return the same instance. Some examples modifying that default behavior: ```javascript let App = Ember.Application.create(); App.Person = Ember.Object.extend(); App.Orange = Ember.Object.extend(); App.Email = Ember.Object.extend(); App.session = Ember.Object.create(); App.register('model:user', App.Person, { singleton: false }); App.register('fruit:favorite', App.Orange); App.register('communication:main', App.Email, { singleton: false }); App.register('session', App.session, { instantiate: false }); ```

#### Parameters:

- `fullName` String
  type:name (e.g., 'model:user')
- `factory` Function
  (e.g., App.Person)
- `options` Object
  (optional) disable instantiation or singleton usage

### `registeredOption`

(

- `fullName`
- `optionName`

)
Object public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:133`

Return a specific registered option for a particular factory.

#### Parameters:

- `fullName` String
- `optionName` String

#### Returns:

Object: options

### `registeredOptions`

(

- `fullName`

)
Object public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:154`

Return registered options for a particular factory.

#### Parameters:

- `fullName` String

#### Returns:

Object: options

### `registeredOptionsForType`

(

- `type`

)
Object public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:195`

Return the registered options for all factories of a type.

#### Parameters:

- `type` String

#### Returns:

Object: options

### `registerOption`

(

- `fullName`
- `optionName`
- `options`

)
public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:122`

Register an option for a particular factory.

#### Parameters:

- `fullName` String
- `optionName` String
- `options` Object

### `registerOptions`

(

- `fullName`
- `options`

)
public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:144`

Register options for a particular factory.

#### Parameters:

- `fullName` String
- `options` Object

### `registerOptionsForType`

(

- `type`
- `options`

)
public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:164`

Allow registering options for all factories of a type. ```javascript let App = Ember.Application.create(); let appInstance = App.buildInstance(); // if all of type `connection` must not be singletons appInstance.registerOptionsForType('connection', { singleton: false }); appInstance.register('connection:twitter', TwitterConnection); appInstance.register('connection:facebook', FacebookConnection); let twitter = appInstance.lookup('connection:twitter'); let twitter2 = appInstance.lookup('connection:twitter'); twitter === twitter2; // => false let facebook = appInstance.lookup('connection:facebook'); let facebook2 = appInstance.lookup('connection:facebook'); facebook === facebook2; // => false ```

#### Parameters:

- `type` String
- `options` Object

### `removeObserver`

(

- `key`
- `target`
- `method`

)
public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:385`

Remove an observer you have previously registered on this object. Pass the same key, target, and method you passed to `addObserver()` and your target will no longer receive notifications.

#### Parameters:

- `key` String
  The key to observer
- `target` Object
  The target object to invoke
- `method` String | Function
  The method to invoke.

### `reopen`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:721`

Augments a constructor's prototype with additional properties and functions: ```javascript const MyObject = Ember.Object.extend({ name: 'an object' }); o = MyObject.create(); o.get('name'); // 'an object' MyObject.reopen({ say(msg){ console.log(msg); } }) o2 = MyObject.create(); o2.say("hello"); // logs "hello" o.say("goodbye"); // logs "goodbye" ``` To add functions and properties to the constructor itself, see `reopenClass`

### `reopenClass`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:757`

Augments a constructor's own properties and functions: ```javascript const MyObject = Ember.Object.extend({ name: 'an object' }); MyObject.reopenClass({ canBuild: false }); MyObject.canBuild; // false o = MyObject.create(); ``` In other words, this creates static properties and functions for the class. These are only available on the class and not on any instance of that class. ```javascript const Person = Ember.Object.extend({ name: "", sayHello() { alert("Hello. My name is " + this.get('name')); } }); Person.reopenClass({ species: "Homo sapiens", createPerson(newPersonsName){ return Person.create({ name:newPersonsName }); } }); let tom = Person.create({ name: "Tom Dale" }); let yehuda = Person.createPerson("Yehuda Katz"); tom.sayHello(); // "Hello. My name is Tom Dale" yehuda.sayHello(); // "Hello. My name is Yehuda Katz" alert(Person.species); // "Homo sapiens" ``` Note that `species` and `createPerson` are *not* valid on the `tom` and `yehuda` variables. They are only valid on `Person`. To add functions and properties to instances of a constructor by extending the constructor's prototype see `reopen`

### `resolveRegistration`

(

- `fullName`

)
Function public

Inherited from RegistryProxyMixin: `packages/ember-runtime/lib/mixins/registry_proxy.js:21`

Given a fullName return the corresponding factory.

#### Parameters:

- `fullName` String

#### Returns:

Function: fullName's factory

### `set`

(

- `keyName`
- `value`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:164`

Sets the provided key or path to the value. ```javascript record.set("key", value); ``` This method is generally very similar to calling `object["key"] = value` or `object.key = value`, except that it provides support for computed properties, the `setUnknownProperty()` method and property observers. ### Computed Properties If you try to set a value on a key that has a computed property handler defined (see the `get()` method for an example), then `set()` will call that method, passing both the value and key instead of simply changing the value itself. This is useful for those times when you need to implement a property that is composed of one or more member properties. ### Unknown Properties If you try to set a value on a key that is undefined in the target object, then the `setUnknownProperty()` handler will be called instead. This gives you an opportunity to implement complex "virtual" properties that are not predefined on the object. If `setUnknownProperty()` returns undefined, then `set()` will simply set the value on the object. ### Property Observers In addition to changing the property, `set()` will also register a property change with the object. Unless you have placed this call inside of a `beginPropertyChanges()` and `endPropertyChanges(),` any "local" observers (i.e. observer methods declared on the same object), will be called immediately. Any "remote" observers (i.e. observer methods declared on another object) will be placed in a queue and called at a later time in a coalesced manner.

#### Parameters:

- `keyName` String
  The property to set
- `value` Object
  The value to set or `null`.

#### Returns:

Object: The passed value

### `setProperties`

(

- `hash`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:213`

Sets a list of properties at once. These properties are set inside a single `beginPropertyChanges` and `endPropertyChanges` batch, so observers will be buffered. ```javascript record.setProperties({ firstName: 'Charles', lastName: 'Jolley' }); ```

#### Parameters:

- `hash` Object
  the hash of keys and values to set

#### Returns:

Object: The passed in hash

### `setupRegistry`

(

- `registry`
- `options`

)
private

Defined in `packages/ember-application/lib/system/engine-instance.js:201`

#### Parameters:

- `registry` Registry
- `options` BootOptions

### `toggleProperty`

(

- `keyName`

)
Boolean public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:473`

Set the value of a boolean property to the opposite of its current value. ```javascript starship.toggleProperty('warpDriveEngaged'); ```

#### Parameters:

- `keyName` String
  The name of the property to toggle

#### Returns:

Boolean: The new property value

### `toString`

() String public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:506`

Returns a string representation which attempts to provide more information than Javascript's `toString` typically does, in a generic way for all Ember objects. ```javascript const Person = Ember.Object.extend() person = Person.create() person.toString() //=> "" ``` If the object's class is not defined on an Ember namespace, it will indicate it is a subclass of the registered superclass: ```javascript const Student = Person.extend() let student = Student.create() student.toString() //=> "<(subclass of Person):ember1025>" ``` If the method `toStringExtension` is defined, its return value will be included in the output. ```javascript const Teacher = Person.extend({ toStringExtension() { return this.get('fullName'); } }); teacher = Teacher.create() teacher.toString(); //=> "" ```

#### Returns:

String: string representation

### `unregister`

(

- `fullName`

)
public

Inherited from RegistryProxyMixin but overwritten in `packages/ember-application/lib/system/engine-instance.js:116`

Unregister a factory.

Overrides `RegistryProxy#unregister` in order to clear any cached instances of the unregistered factory.

#### Parameters:

- `fullName` String

### `willDestroy`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:479`

Override to implement teardown.

## Properties

### `__container__`

Ember.Container private

Inherited from ContainerProxyMixin: `packages/ember-runtime/lib/mixins/container_proxy.js:18`

The container stores state.

### `concatenatedProperties`

Array public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:256`

Defines the properties that will be concatenated from the superclass (instead of overridden). By default, when you extend an Ember class a property defined in the subclass overrides a property with the same name that is defined in the superclass. However, there are some cases where it is preferable to build up a property's value by combining the superclass' property value with the subclass' value. An example of this in use within Ember is the `classNames` property of `Ember.View`. Here is some sample code showing the difference between a concatenated property and a normal one: ```javascript const Bar = Ember.Object.extend({ // Configure which properties to concatenate concatenatedProperties: ['concatenatedProperty'], someNonConcatenatedProperty: ['bar'], concatenatedProperty: ['bar'] }); const FooBar = Bar.extend({ someNonConcatenatedProperty: ['foo'], concatenatedProperty: ['foo'] }); let fooBar = FooBar.create(); fooBar.get('someNonConcatenatedProperty'); // ['foo'] fooBar.get('concatenatedProperty'); // ['bar', 'foo'] ``` This behavior extends to object creation as well. Continuing the above example: ```javascript let fooBar = FooBar.create({ someNonConcatenatedProperty: ['baz'], concatenatedProperty: ['baz'] }) fooBar.get('someNonConcatenatedProperty'); // ['baz'] fooBar.get('concatenatedProperty'); // ['bar', 'foo', 'baz'] ``` Adding a single property that is not an array will just add it in the array: ```javascript let fooBar = FooBar.create({ concatenatedProperty: 'baz' }) view.get('concatenatedProperty'); // ['bar', 'foo', 'baz'] ``` Using the `concatenatedProperties` property, we can tell Ember to mix the content of the properties. In `Ember.Component` the `classNames`, `classNameBindings` and `attributeBindings` properties are concatenated. This feature is available for you to use throughout the Ember object model, although typical app developers are likely to use it infrequently. Since it changes expectations about behavior of properties, you should properly document its usage in each individual concatenated property (to not mislead your users to think they can override the property in a subclass).

Default: null

### `engine`

Ember.Engine private

Defined in `packages/ember-application/lib/system/engine-instance.js:29`

The base `Engine` for which this is an instance.

### `isDestroyed`

Unknown public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:403`

Destroyed object property flag. if this property is `true` the observers and bindings were already removed by the effect of calling the `destroy()` method.

Default: false

### `isDestroying`

Unknown public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:428`

Destruction scheduled flag. The `destroy()` method has been called. The object stays intact until the end of the run loop at which point the `isDestroyed` flag is set.

Default: false

### `mergedProperties`

Array public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:329`

Defines the properties that will be merged from the superclass (instead of overridden). By default, when you extend an Ember class a property defined in the subclass overrides a property with the same name that is defined in the superclass. However, there are some cases where it is preferable to build up a property's value by merging the superclass property value with the subclass property's value. An example of this in use within Ember is the `queryParams` property of routes. Here is some sample code showing the difference between a merged property and a normal one: ```javascript const Bar = Ember.Object.extend({ // Configure which properties are to be merged mergedProperties: ['mergedProperty'], someNonMergedProperty: { nonMerged: 'superclass value of nonMerged' }, mergedProperty: { page: {replace: false}, limit: {replace: true} } }); const FooBar = Bar.extend({ someNonMergedProperty: { completelyNonMerged: 'subclass value of nonMerged' }, mergedProperty: { limit: {replace: false} } }); let fooBar = FooBar.create(); fooBar.get('someNonMergedProperty'); // => { completelyNonMerged: 'subclass value of nonMerged' } // // Note the entire object, including the nonMerged property of // the superclass object, has been replaced fooBar.get('mergedProperty'); // => { // page: {replace: false}, // limit: {replace: false} // } // // Note the page remains from the superclass, and the // `limit` property's value of `false` has been merged from // the subclass. ``` This behavior is not available during object `create` calls. It is only available at `extend` time. In `Ember.Route` the `queryParams` property is merged. This feature is available for you to use throughout the Ember object model, although typical app developers are likely to use it infrequently. Since it changes expectations about behavior of properties, you should properly document its usage in each individual merged property (to not mislead your users to think they can override the property in a subclass).

Default: null